#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "helper_fns.h"

extern char local_filename[];
extern char filename[];
extern char *profile;
extern int want_daemon;
extern int verbosity;

int handle_args(int argc, char **argv) {

  int x = 0;
  int args = argc - 1;
  int p = 0, d = 0, b = 0, q = 0, s = 0, v = 0, h = 0, n = 0, vn = 0;

  for (x = 1; x <= args; x++) {
    if (strcmp(argv[x], "-p") == 0) { p = 1; }
    else if (strcmp(argv[x], "-d") == 0) { d = 1; }
    else if (strcmp(argv[x], "-b") == 0) { b = 1; }
    else if (strcmp(argv[x], "-q") == 0) { q = 1; }
    else if (strcmp(argv[x], "-n") == 0) { n = 1; }
    else if (strcmp(argv[x], "-s") == 0) { s = 1; }
    else if (strcmp(argv[x], "-v") == 0) { v = 1; }
    else if (strcmp(argv[x], "-V") == 0) { vn = 1; }
    else if (strcmp(argv[x], "--version") == 0) { vn = 1; }
    else if (strcmp(argv[x], "-h") == 0) { h = 1; }
    else if (strcmp(argv[x], "-help") == 0) { h = 1; }
    else if (strcmp(argv[x], "--help") == 0) { h = 1; }
  }
  if (d == 1 && b == 1) { die("can't specify both -d and -b"); }
  else if (q == 1 && v == 1) { die("can't specify both -q and -v"); }
  else if (q == 1 && s == 1) { die("can't specify both -q and -s"); }
  else if (s == 1 && v == 1) { die("can't specify both -s and -v"); }
  else if (q == 1 && n == 1) { die("can't specify both -q and -n"); }
  else if (s == 1 && n == 1) { die("can't specify both -s and -n"); }
  else if (v == 1 && n == 1) { die("can't specify both -v and -n"); }

  for (x = 1; x <= args; x++) {
    if (strcmp(argv[x], "-p") == 0) {
      if (args > x) { profile = argv[x + 1]; }
      else { die("need -p name_of_profile"); }
    }
  }

  if (h == 1) {
    puts("Usage: joytran [option]\n");

    puts("-V / --version          version");
    puts("-h / --help             help (this)");
    puts("-s / -q / -n / -v       silent / quiet / normal / verbose");
    puts("-b / -d                 background / daemon");
    puts("-p name                 profile\n");

    puts("mail bug reports and suggestions to " EMAIL);
    exit(0);
  }

  if (vn == 1) {
    puts("joytran-" VERSION ", ©2011-2012 Timothy Beyer");
    exit(0);
  }

  if (v == 1) { verbosity = 2; }
  else if (q == 1) { verbosity = 0; }
  else if (s == 1) { verbosity = -1; }
  else { verbosity = 1; }

  if (p == 0) { profile = "default"; }

  /* construct local configuration file */
  local_config_filename(profile, local_filename);
  /* construct system-wide configuration file */
  system_config_filename(profile, filename);

  want_daemon = 0;
  if (d == 1) { want_daemon = 1; }
  else if (b == 1) { want_daemon = 0; }

  return 0;
}
